import pygst
pygst.require("0.10")
import gst, sys, gstIceSink, gobject

def emisor(args):
    pipe = gst.Pipeline("mainPipe")

    src = gst.element_factory_make("filesrc","srcFromFile")
    src.set_property("location",args[1])

    sink = gstIceSink.gstIceSink("sinkToIce")
    sink.set_property('topic', 'muestra')
    #sink.set_property('topic-manager', 'IceStorm/TopicManager -t:tcp -h 127.0.0.1 -p 9999')
    sink.set_property('topic-manager','IceStorm/TopicManager -t:tcp -h mauchly.inf-cr.uclm.es -p 9999')

    pipe.add(src, sink)
    gst.element_link_many(src, sink)
    pipe.set_state(gst.STATE_PLAYING)

    loop = gobject.MainLoop()

    def events(bus, msg):
        t = msg.type
        if t == gst.MESSAGE_EOS: # En Of Stream
            loop.quit()
            
        elif t == gst.MESSAGE_ERROR: # another error
            e, d = msg.parse_error()
            print "ERROR:",e, d
            loop.quit()
        
        return True

    pipe.get_bus().add_watch(events)

    try:
        print "Playing..."
        loop.run()
    except KeyboardInterrupt: # if Ctrl+C pressed
        pass

    print "\nStopping..."
    loop.quit()
    pipe.set_state(gst.STATE_NULL)
    # does it freeze setting the pipe to NULL?

    print "Bye!"    
    return 0



def main(args):

    if len(args) < 2:
        print "Usage: "+args[0]+" <filename.ogg>"
        return -1

    emisor(args)
    return 0

if __name__ == ("__main__"):
    sys.exit(main(sys.argv))

 
