# -*- coding: utf-8 -*-

import pygst
pygst.require("0.10")
import gst, gobject
gobject.threads_init()

import sys, time, array, Ice, IceStorm
Ice.loadSlice("-I/usr/share/slice --all /usr/share/gstice/slice/gstice.ice")
import GSTICE

class gstIceSink(gst.BaseSink):

    __gsttemplates__ = (
        gst.PadTemplate("sink",
                        gst.PAD_SINK,
                        gst.PAD_ALWAYS,
                        gst.caps_new_any()),
        )

    def __init__(self, name, bitrate=32000):
        self.__gobject_init__()
        self.set_name(name)
        self.bitrate = bitrate 
        self.com = None
        self.topic_mgr_endp = None
        self.topic = None
        
    def run(self):
        if not (self.topic_mgr_endp and self.topic):
            raise Exception, "You must set the 'topic-manager' property"
        
        self.com = Ice.initialize([])

        obj = self.com.stringToProxy(self.topic_mgr_endp)
        tpcMgr = IceStorm.TopicManagerPrx.checkedCast(obj)

        try:
            topic = tpcMgr.retrieve(self.topic)
        except IceStorm.NoSuchTopic:
            topic = tpcMgr.create(self.topic)

        pub = topic.getPublisher()
        pub = pub.ice_datagram()
        print pub

        self.channel = GSTICE.iByteSeq.WPrx.uncheckedCast(pub)

    def do_render(self, buffer):
        if not self.com:
            self.run()

        self.get_state()

        sys.stdout.write(".")
        sys.stdout.flush()

        before = time.time()
        self.channel.set(array.array("B", buffer.data).tolist())
        after = time.time()

        elapsed = (after-before)*1000 # ms
        ilapso = buffer.size/(self.bitrate/1000) # ms

        wait = (ilapso-elapsed)/1000 # s
        if wait < 0:
            bitrate = self.bitrate - self.bitrate/8
            print "Cannot send %d Bps, lowering at %d Bps" % (self.bitrate, bitrate)
            self.bitrate = bitrate
        else:
            time.sleep(wait)

        return gst.FLOW_OK

    def set_property(self, key, value):
        if key == "topic-manager":
            self.topic_mgr_endp = value
        elif key == "topic":
            self.topic = value
        else:
            gst.BaseSink.set_property(self, key, value)
            
    def get_property(self, key):
        try:
            return self.__dict__[key]
        except KeyError:
            return gst.BaseSink.get_property(self, key)
    

gobject.type_register(gstIceSink)


